| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | List of all members
cv::ximgproc::StructuredEdgeDetection Class Referenceabstract
Extended Image Processing » Structured forests for fast edge detection

Class implementing edge detection algorithm from [52] : More...

`#include <opencv2/ximgproc/structured_edge_detection.hpp>`

Inheritance diagram for cv::ximgproc::StructuredEdgeDetection:

## Public Member Functions
virtual void | computeOrientation (cv::InputArray _src, cv::OutputArray _dst) const =0
| The function computes orientation from edge image. More...
virtual void | detectEdges (cv::InputArray _src, cv::OutputArray _dst) const =0
| The function detects edges in src and draw them to dst. More...
virtual void | edgesNms (cv::InputArray edge_image, cv::InputArray orientation_image, cv::OutputArray _dst, int r=2, int s=0, float m=1, bool isParallel=true) const =0
| The function edgenms in edge image and suppress edges where edge is stronger in orthogonal direction. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing edge detection algorithm from [52] :

## Member Function Documentation

## ◆ computeOrientation()

virtual void cv::ximgproc::StructuredEdgeDetection::computeOrientation | ( | cv::InputArray | _src,
|  | cv::OutputArray | _dst
| ) |  | const
| pure virtual

Python:
| _dst | = | cv.ximgproc_StructuredEdgeDetection.computeOrientation( | _src[, _dst] | )

The function computes orientation from edge image.

Parameters

  _src | edge image.
  _dst | orientation image.

## ◆ detectEdges()

virtual void cv::ximgproc::StructuredEdgeDetection::detectEdges | ( | cv::InputArray | _src,
|  | cv::OutputArray | _dst
| ) |  | const
| pure virtual

Python:
| _dst | = | cv.ximgproc_StructuredEdgeDetection.detectEdges( | _src[, _dst] | )

The function detects edges in src and draw them to dst.

The algorithm underlies this function is much more robust to texture presence, than common approaches, e.g. Sobel

Parameters

  _src | source image (RGB, float, in [0;1]) to detect edges
  _dst | destination image (grayscale, float, in [0;1]) where edges are drawn

See also
  Sobel, Canny

## ◆ edgesNms()

virtual void cv::ximgproc::StructuredEdgeDetection::edgesNms | ( | cv::InputArray | edge_image,
|  | cv::InputArray | orientation_image,
|  | cv::OutputArray | _dst,
|  | int | r = `2`,
|  | int | s = `0`,
|  | float | m = `1`,
|  | bool | isParallel = `true`
| ) |  | const
| pure virtual

Python:
| _dst | = | cv.ximgproc_StructuredEdgeDetection.edgesNms( | edge_image, orientation_image[, _dst[, r[, s[, m[, isParallel]]]]] | )

The function edgenms in edge image and suppress edges where edge is stronger in orthogonal direction.

Parameters

  edge_image | edge image from detectEdges function.
  orientation_image | orientation image from computeOrientation function.
  _dst | suppressed image (grayscale, float, in [0;1])
  r | radius for NMS suppression.
  s | radius for boundary suppression.
  m | multiplier for conservative suppression.
  isParallel | enables/disables parallel computing.

The documentation for this class was generated from the following file:

- opencv2/ximgproc/structured_edge_detection.hpp